using System;
using System.Collections.Generic;
using System.Text;
using CLab.Auxiliary;

namespace CLab
{
    /// <summary>
    /// An expression consisting of a left and right side and an operator
    /// </summary>
    public class BinaryExpression:Expression
    {
        private Expression right;
        private Expression left;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="left">left expression</param>
        /// <param name="type">operator</param>
        /// <param name="right">right expression</param>
        public BinaryExpression(Expression left, Common.ExprType type, Expression right)
            : base(type)
        {
            this.left = left;
            this.right = right;

        }

        /// <summary>
        /// Returns left side
        /// </summary>
        internal Expression Left
        {
            get { return left; }
        }
        /// <summary>
        /// returns right side
        /// </summary>
        internal Expression Right
        {
            get { return right; }
        }

    }
}
