/*========================================================================
        Copyright (C) 2006 by Geir-Tore Lindsve, Torbjrn Meistad 
        and Yngve Raudberget, hereby refered to as "the authors".
                        All rights reserved

    Permission is hereby granted, without written agreement and without
    license or royalty fees, to use, reproduce, prepare derivative
    works, distribute, and display this software and its documentation
    for NONCOMMERCIAL RESEARCH AND EDUCATIONAL PURPOSES, provided 
    that (1) the above copyright notice and the following two paragraphs 
    appear in all copies of the source code and (2) redistributions, 
    including without limitation binaries, reproduce these notices in 
    the supporting documentation. 

    IN NO EVENT SHALL THE AUTHORS, OR DISTRIBUTORS OF THIS SOFTWARE 
    BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
    OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE 
    AND ITS DOCUMENTATION, EVEN IF THE AUTHORS OR ANY OF THE ABOVE 
    PARTIES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

    THE AUTHORS SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
    BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
    FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
    ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO
    OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
    MODIFICATIONS.
========================================================================*/

using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace CLab.Data
{
    /// <summary>
    /// The Type class represents a CLab type.
    /// There are two variants of Type objects:
    /// 1. Type(String typeName, ArrayList states)
    ///        contains a enumeration of valid states for the type.
    /// 2. Type(String typeName, int startOfRange, int endOfRange)
    ///        contains a set range.
    /// </summary>
    public abstract class Type
    {
        private String typeName;

        /// <summary>
        /// Initializes a new instance of the <see cref="T:Type"/> class.
        /// </summary>
        /// <param name="typeName">Name of the type.</param>
        public Type(String typeName)
        {
            this.typeName = typeName;
        }

        /// <summary>
        /// Gets or sets the string representation of the name of the type.
        /// </summary>
        /// <value>The name of the type.</value>
        public String TypeName
        {
            get { return typeName; }
            set { typeName = value; }
        }

        /// <summary>
        /// Returns the name of the type.
        /// </summary>
        public override string ToString()
        {
            return typeName;     
        }
    }
}
