using System;
using System.Collections.Generic;
using System.Text;
using CLab.Auxiliary;

namespace CLab
{
    /// <summary>
    /// An expression consisting of a single id-element
    /// </summary>
    public class IdExpression : Expression
    {
        private String id;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="id">A string with the name of the variable or an enumeration constant</param>
        public IdExpression(String id)
            : base(Common.ExprType.et_id)
        {
            this.id = id;
        }

        /// <summary>
        /// Returns the Id value
        /// </summary>
        public String Id
        {
            get { return id; }
        }
    }
}
