using System;
using System.Collections.Generic;
using System.Text;
using CLab.Auxiliary;

namespace CLab
{
    /// <summary>
    /// Expression consisting of an integer
    /// </summary>
    public class IntExpression : Expression
    {
        private int? integer;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="integer">Integer value of</param>
        public IntExpression(int integer)
            : base(Common.ExprType.et_val)
        {
            this.integer = integer;
        }

        /// <summary>
        /// Returns the integer value
        /// </summary>
        public int IntegerValue
        {
            get { return (int)this.integer; }
        }
    }
}
