﻿using System;
using System.Collections.Generic;
using System.Text;
using CLab.Auxiliary;

namespace CLab
{

    class LayoutTypeRange : LayoutType
    {
        private int startOfRange;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type</param>
        /// <param name="startOfRange">Start of range</param>
        public LayoutTypeRange(String typeName, int startOfRange, int domainSize)
            : base(typeName, booleanVarNumber(domainSize), domainSize)
        {
            this.startOfRange = startOfRange;
        }

        /// <returns>Integer value of the start of range</returns>
        public int StartOfRange
        {
            get { return startOfRange; }
        }

        public override string ToString()
        {
            return (String.Format("<LayoutTypeRange>, Start of range: {0}, {1}", StartOfRange, base.ToString()));
        }
    }
}