﻿using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;

namespace CLab
{
    /// <summary>
    /// The Variable class represents a CLab variable
    /// In addition to the types set by Type objects, CLab has an internal boolean type named bool
    /// </summary>
    public class LayoutVariable
    {
        List<int> bddVar = new List<int>();
        int typeIndex;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type to use for this variable</param>
        /// <param name="variableName">Name of the variable</param>
        public LayoutVariable(List<int> bddVar, int typeIndex)
        {
            this.bddVar = bddVar;
            this.typeIndex = typeIndex;
        }

        public List<int> BddVar
        {
            get { return bddVar; }
        }

        public int TypeIndex
        {
            get { return typeIndex; }
        }
        
        public override string ToString()
        {
            String res = "";
            for (int i = 0; i < bddVar.Count; i++)
            {
                res += bddVar[i] + ", ";
            }
            return (String.Format("<LayoutVariable> type index: {0} \nBDD variables: {1}", typeIndex, res));
        }
    }
}

