using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;

namespace CLab
{
    /// <summary>
    /// The Type class represents a CLab type
    /// There are two variants of Type objects:
    /// 1. Type(String typeName, ArrayList states)
    ///        contains a enumeration of valid states for the type
    /// 2. Type(String typeName, int startOfRange, int endOfRange)
    ///        contains a set range
    /// </summary>
    public abstract class Type
    {
        private String typeName;
        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type</param>
        public Type(String typeName)
        {
            this.typeName = typeName;
        }

        /// <returns>The string representation of the type name</returns>
        public String TypeName
        {
            get { return typeName; }
            set { typeName = value; }
        }

        public override string ToString()
        {
            return typeName;     
        }
    }
}
