﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CLab
{
    /// <summary>
    /// The Type class represents a CLab type
    /// TypeRange represents a range type
    /// </summary>
    public class TypeRange : Type
    {
        private int startOfRange;
        private int endOfRange;
        
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type</param>
        /// <param name="startOfRange">Start of range</param>
        /// <param name="endOfRange">End of range</param>
        public TypeRange(String typeName, int startOfRange, int endOfRange) : base(typeName)
        {
            this.startOfRange = startOfRange;
            this.endOfRange = endOfRange;
        }

        /// <returns>Integer value of the start of range</returns>
        public int StartOfRange
        {
            get { return startOfRange; }
            set { startOfRange = value; }
        }

        ///<returns>Integer value of the end of range</returns>
        public int EndOfRange
        {
            get { return endOfRange; }
            set { endOfRange = value; }
        }

        public override string ToString()
        {
            String range = "[" + this.startOfRange + " . . " + this.endOfRange + "]";
            return (String.Format("Range: {0} {1}, {2}", TypeName, range, base.ToString()));
        }


    }
}
