using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;

namespace CLab
{
    /// <summary>
    /// The Variable class represents a CLab variable
    /// In addition to the types set by Type objects, CLab has an internal boolean type named bool
    /// </summary>
    public class Variable
    {
        private String typeName;
        private String variableName;

        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="typeName">Name of the type to use for this variable</param>
        /// <param name="variableName">Name of the variable</param>
        public Variable(String typeName, String variableName)
        {
            this.typeName = typeName;
            this.variableName = variableName;
        }

        ///<returns>The name of the variable type</returns>
        public String TypeName
        {
            get { return typeName; }
            set { typeName = value; }
        }

        ///<returns>The name of the variable</returns>
        public String VariableName
        {
            get { return variableName; }
            set { variableName = value; }
        }

        public override string ToString()
        {
            return (String.Format("{0} {1}, ", typeName, variableName));
        }
    }
}
