using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Casper;

namespace Casper.Algorithm.VariableOrdering
{
    /// <summary>
    /// An implementation of ascending variable order.
    /// </summary>
    public class AscendingVarOrder:IVariableOrdering
    {
        /// <summary>
        /// Since the variables are stored increasingly, we 
        /// return the number from input without any calculation.
        /// </summary>
        /// <param name="numberInQueue">The number in queue.</param>
        /// <returns>Number in queue.</returns>
        public int GetNextVar(int numberInQueue)
        {
            return numberInQueue;
        }
    }
}
