﻿/*========================================================================
        Copyright (C) 2006 by Geir-Tore Lindsve, Torbjørn Meistad 
        and Yngve Raudberget, hereby refered to as "the authors".
                        All rights reserved

    Permission is hereby granted, without written agreement and without
    license or royalty fees, to use, reproduce, prepare derivative
    works, distribute, and display this software and its documentation
    for NONCOMMERCIAL RESEARCH AND EDUCATIONAL PURPOSES, provided 
    that (1) the above copyright notice and the following two paragraphs 
    appear in all copies of the source code and (2) redistributions, 
    including without limitation binaries, reproduce these notices in 
    the supporting documentation. 

    IN NO EVENT SHALL THE AUTHORS, OR DISTRIBUTORS OF THIS SOFTWARE 
    BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, 
    OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF THIS SOFTWARE 
    AND ITS DOCUMENTATION, EVEN IF THE AUTHORS OR ANY OF THE ABOVE 
    PARTIES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

    THE AUTHORS SPECIFICALLY DISCLAIM ANY WARRANTIES, INCLUDING,
    BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
    FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
    ON AN "AS IS" BASIS, AND THE AUTHORS AND DISTRIBUTORS HAVE NO
    OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR
    MODIFICATIONS.
========================================================================*/

using System;
using System.Collections.Generic;
using System.Text;

namespace Casper
{
    /// <summary>
    /// A class for Caspers static data.
    /// </summary>
    public static class StaticData
    {
        /// <summary>
        /// The different operators possible in an expression
        /// </summary>
        public enum Operators
        {
            /// <summary>
            /// Implication.
            /// </summary>
            impl, 
            /// <summary>
            /// Or.
            /// </summary>
            or, 
            /// <summary>
            /// And.
            /// </summary>
            and, 
            /// <summary>
            /// Less than or equal.
            /// </summary>
            lte, 
            /// <summary>
            /// Greater than or equal.
            /// </summary>
            gte, 
            /// <summary>
            /// Less than.
            /// </summary>
            lt, 
            /// <summary>
            /// Greater than.
            /// </summary>
            gt, 
            /// <summary>
            /// Not equal.
            /// </summary>
            ne, 
            /// <summary>
            /// Equal.
            /// </summary>
            eq, 
            /// <summary>
            /// Minus.
            /// </summary>
            minus,
            /// <summary>
            /// Plus.
            /// </summary>
            plus, 
            /// <summary>
            /// Modulo division.
            /// </summary>
            mod, 
            /// <summary>
            /// Division.
            /// </summary>
            div, 
            /// <summary>
            /// Times.
            /// </summary>
            times
        };

        /// <summary>
        /// Used to tell the difference between not or neg in
        /// a NotNegExpression
        /// </summary>
        public enum NotNeg
        {
            /// <summary>
            /// Negation.
            /// </summary>
            neg, 
            /// <summary>
            /// Inversion.
            /// </summary>
            not
        };
    }

    /// <summary>
    /// The different csp variable orderings.
    /// </summary>
    public enum CspVariableOrdering
    {
        /// <summary>
        /// Static variable ordering.
        /// </summary>
        vo_static,
        /// <summary>
        /// Minimum width variable ordering.
        /// </summary>
        vo_minwidth
    };
}
